package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.RegistryMapper;
import com.sa.ibiz.demo.demo.domain.Registry;
import com.sa.ibiz.demo.demo.service.RegistryService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.RegistrySearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;


/**
 * 实体[Registry] 服务对象接口实现
 */
@Service
public class RegistryServiceImpl extends ServiceImplBase<RegistryMapper, Registry> implements RegistryService{


    @Resource
    private RegistryMapper registryMapper;


    @Override
    public boolean create(Registry et) {
        this.beforeCreate(et);
        String primaryKey=et.getRegistryid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setRegistryid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public Registry get(Registry et) {
        String primaryKey=et.getRegistryid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setRegistryid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(Registry et) {
        String primaryKey=et.getRegistryid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setRegistryid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(Registry et){
        String primaryKey=et.getRegistryid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setRegistryid(primaryKey);
          }
		     this.registryMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(Registry et){
		return et.getRegistryid();  
    }

    @Override
    public boolean getDraft(Registry et)  {
            return true;
    }

	public List<Registry> listDefault(RegistrySearchFilter filter) {
		return registryMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<Registry> searchDefault(RegistrySearchFilter filter) {
		return registryMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return registryMapper.selectRow(sql);
    }

 }